import java.io.*;
import oracle.portal.provider.v1.*;
import oracle.portal.provider.v1.http.*;

public class MyEditRenderer extends BaseManagedRenderer {

    public void renderBody(PortletRenderRequest pr) throws PortletException {

        try {
            // ҏW[hŃ[U[sANV擾.
            String actionParam = PortletRendererUtil.getEditFormParameter(pr);
            String action = pr.getParameter(actionParam);

            MyPersonalizationObject data =
                (MyPersonalizationObject)PortletRendererUtil.getEditData(pr);

            // OK,APPLYɏs.ȊO͕ҏWʂ\.
            if (action != null)
            {
            // p[\iCYf[^LbVL[擾čXV
                String cache_key = data.getCacheKey();
                cache_key = getNewVersion(cache_key);
                data.setCacheKey(cache_key);

                data.setPortletTitle(pr.getParameter("mfp_title"));
                data.putString(MyPersonalizationObject.GREETING,
                               pr.getParameter(MyPersonalizationObject.GREETING));
                PortletRendererUtil.submitEditData(pr, data);
            }
            else {
                PrintWriter out = pr.getWriter();
                out.println("<TABLE BORDER=0 CELLSPACING=0>");
                out.println("<TR><TD>Title:</TD>");
                out.print("<TD><INPUT TYPE=\"text\" NAME=\"mfp_title\" " +
                          "SIZE=\"50\" VALUE=\"" + data.getPortletTitle() +
                          "\" </TD></TR>");
                out.println("<TR><TD>Greeting:</TD>");
                out.print("<TD><INPUT TYPE=\"text\" NAME=\"" +
                          MyPersonalizationObject.GREETING + "\" SIZE=\"50\" "+
                          "VALUE=\"");
                out.print(data.getString(MyPersonalizationObject.GREETING) +
                          "\" </TD></TR><TABLE>");
            }
        }
        catch (IOException ioe) { throw new PortletException(ioe); }
    }

    // LbVL[̍XV
    public static String getNewVersion(String cacheKey) {
        int cacheKeyInt;
        try {
            cacheKeyInt = Integer.parseInt(cacheKey) + 1;
        } catch(Exception ex) {
            cacheKeyInt = 0;
        }
        if (cacheKeyInt > 99999999) {
            cacheKeyInt = 0;
        }
        cacheKey = Integer.toString(cacheKeyInt);
        return cacheKey;
    }
}
