(p_pr/* @Copyright (c) 1999-2001, Oracle Corporation Japan. All rights reserved. */

-- Sample Hello World Portlet for Oracle Portal 3.0
-- Usage: SQL> @hello_01 <PROVIDER_SCHEMA>
-- Example: SQL> @hello_01 scott
-- 2001 08/15 by TH

set verify off
set define on

-- |[gbgEvoC_̃pbP[W쐬XL[}𓮓IɎw
undefine PROVIDER_SCHEMA
define PROVIDER_SCHEMA='&&1'

-- |[gbgEvoC_pbP[ẂuHELLO_PROVIDERv
undefine PROVIDER_PACKAGE
define PROVIDER_PACKAGE='HELLO_PROVIDER'

create or replace package &&PROVIDER_SCHEMA..&&PROVIDER_PACKAGE
is
-- voC_API̎:pbP[Wdl

-- e|[gbgɓKIDӂ
    PORTLET_ID constant integer := 1;
-- |[gbǵuHello_Worldv
    PORTLET_NAME constant varchar2(55) := 'Hello_World';
-- |[gbg̕\́uHello Worldv
    DEFAULT_TITLE constant varchar2(55) := 'Hello World';

-- Help܂AboutȂǂ̃voC_Ex\
    procedure show
    (
        p_language in varchar2,
        p_mode in integer
    );

-- KvȔF؁AуZbṼZbgAbvs
-- ʏ͔F؂PortalɔĈŁAKv͂Ȃ
    procedure do_login
    (
        p_provider_id in integer,
        p_browser_cookies in wwpro_api_provider.cookie_table,
        p_provider_cookies out wwpro_api_provider.cookie_table
    );

-- voC_APĨo[WԂ(Oracle Portal 3.0ł͏1Ԃ)
    function get_api_version
    return integer;

-- |[gbggpp[^Ԃ
    function describe_portlet_parameters
    (
        p_provider_id in integer,
        p_portlet_id in integer,
        p_language in varchar2
    )
    return wwpro_api_provider.portlet_parameter_table;

-- w肳ꂽ|[gbgs\ǂԂ
    function is_portlet_runnable
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    return boolean;

-- w肳ꂽ|[gbgɊւڍ׏Ԃ
    function get_portlet
    (
        p_provider_id in integer,
        p_portlet_id  in integer,
        p_language    in varchar2
    )
    return wwpro_api_provider.portlet_record;

-- ̃voC_Ǘ|[gbg̃XgԂ
    function get_portlet_list
    (
        p_provider_id    in integer,
        p_start_row      in integer,
        p_row_count      in integer,
        p_language       in varchar2,
        p_security_level in boolean,
        p_type           in integer
    )
    return wwpro_api_provider.portlet_table;

-- |[^Ey[WɃ|[gbgǉ鎞Ɉxs
    procedure register_portlet
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    );

-- |[^Ey[W|[gbg폜鎞Ɉxs
    procedure deregister_portlet
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    );

-- |[^Ƀ|[gbgEvoC_ǉ鎞Ɉxs
    procedure register_provider
    (
        p_provider_id in integer
    );

-- |[^|[gbgEvoC_폜鎞Ɉxs
    procedure deregister_provider
    (
        p_provider_id in integer
    );

--  |[^Ey[WRs[鎞ɁAKvł΃JX^}CY
--  [U[vt@XGAɕۑ
    procedure copy_portlet
    (
        p_copy_portlet_info in wwpro_api_provider.copy_portlet_record
    );

-- |[gbgo͂HTMLԂ
-- HTML̓e|[^Ey[W̃|[gbgƂċ@\
    procedure show_portlet
    (
        p_portlet_record in out wwpro_api_provider.portlet_runtime_record
    );
end &&PROVIDER_PACKAGE;
/

show errors package &&PROVIDER_SCHEMA..&&PROVIDER_PACKAGE;

create or replace package body &&PROVIDER_SCHEMA..&&PROVIDER_PACKAGE
is
-- voC_API̎:pbP[W{̕

    procedure show
    (
        p_language in varchar2,
        p_mode in integer
    )
    is
    begin
        htp.p('Insert HTML Designtime interfaces here :)');
    end show;

    procedure do_login
    (
        p_provider_id in integer,
        p_browser_cookies in wwpro_api_provider.cookie_table,
        p_provider_cookies out wwpro_api_provider.cookie_table
    )
    is
    begin
        null;
    end do_login;

    function get_api_version
    return integer is
    begin
        return wwpro_api_provider.API_VERSION_1;
    end get_api_version;

    function describe_portlet_parameters
    (
        p_provider_id in integer,
        p_portlet_id in integer,
        p_language in varchar2
    )
    return wwpro_api_provider.portlet_parameter_table is
        l_params wwpro_api_provider.portlet_parameter_table;
    begin
        return l_params;
    end describe_portlet_parameters;

-- in_portlet_runnable Ă΂Tu[`
    function is_runnable
    (
       p_provider_id in integer,
       p_reference_path in varchar2
    )
    return boolean is
    begin
        return true;
    end is_runnable;

-- dvvoC_API 1
    function is_portlet_runnable
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    return boolean is
    begin
        return is_runnable(p_provider_id => p_portlet_instance.provider_id,
                           p_reference_path => p_portlet_instance.reference_path);
    end is_portlet_runnable;


-- dvvoC_API 2
    function get_portlet
    (
        p_provider_id in integer,
        p_portlet_id  in integer,
        p_language    in varchar2
    )
    return wwpro_api_provider.portlet_record is
        l_portlet wwpro_api_provider.portlet_record;
    begin
        l_portlet.timeout := null;
        l_portlet.timeout_msg := null;
        l_portlet.implementation_style :=
        wwpro_api_provider_registry.DATABASE_IMPL;
        l_portlet.implementation_owner := '&&PROVIDER_SCHEMA';
        l_portlet.implementation_name := '&&PROVIDER_PACKAGE';
        l_portlet.api_version := wwpro_api_provider.API_VERSION_1;

        if p_portlet_id = PORTLET_ID then
-- has_show_editTRUEȂJX^}CY\ŁA
-- |[gbg̉EɃJX^}CYEN\
-- ̑̃p[^[ɂĂPDKQƂ̂
            l_portlet.has_show_edit_defaults := false;
            l_portlet.has_show_preview := true;
            l_portlet.language := wwctx_api.get_nls_language;
            l_portlet.content_type := wwpro_api_provider.CONTENT_TYPE_HTML;
            l_portlet.id := PORTLET_ID;
            l_portlet.name := PORTLET_NAME;
            l_portlet.title := DEFAULT_TITLE;
            l_portlet.description := DEFAULT_TITLE;
        else
            raise wwpro_api_provider.PORTLET_NOT_FOUND_EXCEPTION;
        end if;

        return l_portlet;
    end get_portlet;

-- dvvoC_API 3
    function get_portlet_list
    (
        p_provider_id    in integer,
        p_start_row      in integer,
        p_row_count      in integer,
        p_language       in varchar2,
        p_security_level in boolean,
        p_type           in integer
    )
    return wwpro_api_provider.portlet_table is
        l_portlet_list wwpro_api_provider.portlet_table;
        l_cnt number;
    begin
        l_cnt := 0;
        l_cnt := l_cnt + 1;
        l_portlet_list(l_cnt) := get_portlet(p_provider_id => p_provider_id,
                                             p_portlet_id => PORTLET_ID,
                                             p_language => p_language);

        return l_portlet_list;
    end get_portlet_list;

    procedure register_provider
    (
        p_provider_id in integer
    )
    is
    begin
        null;
    end register_provider;

    procedure deregister_provider
    (
        p_provider_id in integer
    )
    is
    begin
        null;
    end deregister_provider;

-- dvvoC_API 4-1
    procedure register_portlet
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    is
    begin
        null;
    end register_portlet;

-- dvvoC_API 4-2
    procedure deregister_portlet
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    is
    begin
        null;
    end deregister_portlet;

    procedure copy_portlet
    (
        p_copy_portlet_info in wwpro_api_provider.copy_portlet_record
    )
    is
    begin
        null;
    end copy_portlet;

-- dvvoC_API 5
-- |[gbg̒jȂvV[W
-- |[gbg̃|[^Ey[Wւ̕`ׂ͂Ă̒A
-- ͂Ă΂vV[Wōs
    procedure show_portlet
    (
        p_portlet_record in out wwpro_api_provider.portlet_runtime_record
    )
    is
    begin
        if p_portlet_record.portlet_id = PORTLET_ID then
-- |[gbg`vĂ鎞
            if p_portlet_record.exec_mode = wwpro_api_provider.MODE_SHOW then
-- |[gbg̃wb_[̕`
                if p_portlet_record.has_title_region then
                    wwui_api_portlet.draw_portlet_header(
                        p_provider_id       => p_portlet_record.provider_id,
                        p_portlet_id        => p_portlet_record.portlet_id,
                        p_title             => DEFAULT_TITLE,
                        p_has_details       => false,
                        p_has_edit          => false,
                        p_has_help          => false,
                        p_has_about         => false,
                        p_back_url          => p_portlet_record.page_url,
                        p_referencepath     => p_portlet_record.reference_path);
                end if;

-- |[gbg̊Og̕` 1(1A2RgAEgƘgȂ)
                wwui_api_portlet.open_portlet(p_has_border => p_portlet_record.has_border);

-- ȉ|[gbg̕`(Web Toolkit𗘗pHTML̃^O`)
-- ftHgĺuHello World!v
                htp.centeropen;
                htp.p('<BR><FONT COLOR=Red><STRONG>Hello World!</STRONG></FONT><BR>');
                htp.centerclose;

-- |[gbg̊Og̕` 2(1A2RgAEgƘgȂ)
                wwui_api_portlet.close_portlet;

-- |[gbgvr[vĂ鎞̓vr[̕\
            elsif p_portlet_record.exec_mode = wwpro_api_provider.MODE_PREVIEW then
                htp.centeropen;
                htp.p('<BR><FONT COLOR=Red><STRONG>Hello World!</STRONG></FONT><BR>');
                htp.centerclose;
            else
                raise wwpro_api_provider.PORTLET_EXECUTION_EXCEPTION;
            end if;
        else
            raise wwpro_api_provider.PORTLET_NOT_FOUND_EXCEPTION;
        end if;
    end show_portlet;
end &&PROVIDER_PACKAGE;
/

show errors package body &&PROVIDER_SCHEMA..&&PROVIDER_PACKAGE;
grant execute on &&PROVIDER_SCHEMA..&&PROVIDER_PACKAGE to public;
commit;
exit
